#include <iostream> 
using namespace std;

int main()
{

    int zbir = 0;
  
    int i = 0;
    int n;
    long o, a, b, ab;
    string ljudi[1000];
    int koliko[1000];
    int ok[1000] = { 0 };
    int ak[1000] = { 0 };
    int bk[1000] = { 0 };
    int abk[1000] = { 0 };
    bool oceNece = true;

   
    //ulaz
    cin >> n >> o >> a >> b >> ab;
    for (int i = 0; i < n; i++)
    {
        cin >> ljudi[i];
        cin >> koliko[i];

        zbir += koliko[i];
    }

    if (zbir > o+a+b+ab)
    {
        oceNece = false;
    }

    //yey
    while(oceNece && i<n)
    {
        

        if (ljudi[i] == "O")
        {
            ok[i] = koliko[i];
            o -= ok[i];
            if (o < 0) oceNece = false;
        }


        else if (ljudi[i] == "A")
        {
            if (a < koliko[i])
            {
                ak[i] = a;
                ok[i] = koliko[i] -ak[i];
                a = 0;
                o -= ok[i];
                if (o < 0) oceNece = false;
            }
            else
            {
                ak[i] = koliko[i];
                a -= ak[i];
            }
        }


        else if (ljudi[i] == "B")
        {
            if (b < koliko[i])
            {
                bk[i] = b;
                ok[i] = koliko[i] - bk[i];
                b = 0;
                o -= ok[i];
                if (o < 0) oceNece = false;
            }
            else
            {
                bk[i] = koliko[i];
                b -= bk[i];
            }
        }
        i++;
    }

    i = 0;

    while(oceNece && i < n)
    {
        if (ljudi[i] == "AB")
        {
            if (koliko[i]>o+a+b+ab)
            {
                oceNece = false;
                
            }

            if (koliko[i]<=ab)
            {
                abk[i] = koliko[i];
                ab -= abk[i];
            }
            else
            {
                abk[i] = ab;
                ab = 0;
                if (koliko[i] - abk[i] <= o)
                {
                    ok[i] = koliko[i]-abk[i];
                    o -= ok[i];
                }
                else
                {
                    ok[i] = o;
                    o = 0;
                    if (koliko[i] - abk[i] -ok[i] <= a)
                    {
                        ak[i] = koliko[i] - abk[i] - ok[i];
                        a -= ak[i];
                    }
                    else
                    {
                        ak[i] = a;
                        a = 0;
                        bk[i] = koliko[i] - abk[i] - ok[i] - ak[i];
                        b -= bk[i];
                    }
                }
            }
        }

        i++;
    }


    if (oceNece)
    {
        cout << "moguce" << "\n";

        for (int i = 0; i < n; i++)
        {
            cout << ok[i] << " " << ak[i] << " " << bk[i] << " " << abk[i] << "\n";
        }
    }
    else
    {
        cout << "nemoguce";
    }
}